VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form Form1 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "www.ActiveVB.de"
   ClientHeight    =   3225
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6360
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3225
   ScaleWidth      =   6360
   StartUpPosition =   3  'Windows-Standard
   Begin MSComctlLib.ListView ListView1 
      Height          =   3255
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   6375
      _ExtentX        =   11245
      _ExtentY        =   5741
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   0
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.
'
'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source!
'
'Autor: Peter K. Sauer       peter.k.sauer@web.de
'
' ListView nach Datum und Zahlwerten sortieren
' Ein ListView kann ber die Zuweisung von Sortspalte, SortOrder und
' Sorted=True normalerweise bequem sortiert werden. Probleme gibt es
' erst, wenn Spalten mit Datum oder Spalten mit numerischen Werten
' sortiert werden sollen, da im ListView eigentlich nur Text darge-
' stellt wird.
' Ein Datum in europischer Schreibweise ist aber nicht sortierbar
' und bei Zahlen wird nicht die Grsse bewertet sondern es geht nach
' dem Wert der ersten Ziffer, dann dem Wert der 2. Ziffer etc

Option Explicit

Private Sub Form_Load()
    Randomize            '-Zufallszahlen neu mischen
    Dim werte As Integer '-Zufallszahl als Ganzzahlvariable
    Dim Datums As String
    Dim Temp As Integer
    Dim i As Integer
    
    ListView1.View = lvwReport
    ListView1.ColumnHeaders.Add , , "Eintrag", 2000
    ListView1.ColumnHeaders.Add , , "Wert", 1000
    ListView1.ColumnHeaders.Add , , "Datum", 1500
    
    
    For i = 1 To 50
        ' Zufallszahl zuweisen
        werte = Rnd * 30000
        
        ' Erstellen eines Zufallsdatums
        ' mit dem Format
        ' //yyyy.mm.dd
        ' dd.mm.yyyy
        Temp = Rnd * 30 + 1
        Datums = Format(Temp, "00")
        Temp = Rnd * 11 + 1
        Datums = Datums & "." & Format(Temp, "00")
        Temp = Rnd * 60 + 1950
        Datums = Datums & "." & Format(Temp, "0000")
        
        ListView1.ListItems.Add i, , i
        ListView1.ListItems(i).ListSubItems.Add , , werte
        ListView1.ListItems(i).ListSubItems.Add , , Datums
    Next i
End Sub

Private Sub ListView1_ColumnClick(ByVal ColumnHeader As MSComctlLib.ColumnHeader)
    ' Bei dem nachstehenden Trick wird eine Dummy-Spalte
    ' in das ListView eingefgt und vor dem Sort mit einem
    ' sortierbaren Datum (yyyy.mm.dd) bzw. Zahl(String mit
    ' vorlaufenden Spaces) gefllt. Nach der Sortierung
    ' wird die Dummy-Spalte wieder eleminiert.
    
    Dim NewSub As Long
    Dim i As Long
    Dim sFormat As String
    Dim Li As ListItem
    
    sFormat = "yyyy.mm.dd hh:mm:ss"
   
    With ListView1
        'ListView ruhig halten, Sichtbarkeit bleibt trotzdem erhalten
        .Visible = False
        
        'zu sortierende Spalte bestimmen
        .SortKey = ColumnHeader.Index - 1
        
        'Dummy-Spalte einfgen mit Breite 0
        .ColumnHeaders.Add , , "Dummy", 0
        
        'Nummer der Dummy-Spalte
        NewSub = .ColumnHeaders.Count - 1
        
        'abfragen auf Spalte mit Datum
        If ColumnHeader.Index = 3 Then
            'Sortiere nach Datum
            For i = .ListItems.Count To 1 Step -1
                Set Li = .ListItems(i)
                
                'Dummy-Spalte mit sortierfhigem Datum belegen
                Li.SubItems(NewSub) = Format(CDate(Li.SubItems(2)), sFormat)
            Next i
            
            'zu sortierende Spalte umbiegen
            .SortKey = NewSub
        
        'abfragen auf Spalte mit Zahlen
        ElseIf ColumnHeader.Index = 2 Then
            
            'Sortiere nach Zahlen
            For i = .ListItems.Count To 1 Step -1
                Set Li = .ListItems(i)
                
                'Dummy-Spalte mit sortierfhiger Zahl belegen
                Li.SubItems(NewSub) = Right(Space(20) & Li.SubItems(1), 20)
            Next i
            
            'zu sortierende Spalte umbiegen
            .SortKey = NewSub
        End If
        
        'SortOrder bestimmen Asc oder Desc
        .SortOrder = lvwAscending
            
        'Sort anstossen
        .Sorted = True
      
        'Dummy-Spalte entfernen
        .ColumnHeaders.Remove .ColumnHeaders.Count
        
        'Zeiger auf 1. Zeile und scrollen
        .ListItems(1).Selected = True
        .ListItems(1).EnsureVisible
            
        'sichtbar machen
        .Visible = True
    End With
End Sub
